/*
 * THE - The Hessling Editor. A text editor similar to VM/CMS xedit.
 * Copyright (C) 1991-1995 Mark Hessling
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to:
 *
 *    The Free Software Foundation, Inc.
 *    675 Mass Ave,
 *    Cambridge, MA 02139 USA.
 *
 *
 * If you make modifications to this software that you feel increases
 * it usefulness for the rest of the community, please email the
 * changes, enhancements, bug fixes as well as any and all ideas to me.
 * This software is going to be maintained and enhanced as deemed
 * necessary by the community.
 *
 * Mark Hessling                     email: M.Hessling@gu.edu.au
 * 36 David Road                     Phone: +61 7 849 7731
 * Holland Park                      Fax:   +61 7 875 5314
 * QLD 4121
 * Australia
 */

/*
$Id: DEFINES.H 2.0 1995/01/26 16:34:30 MH Release MH $
*/

/*---------------------------------------------------------------------*/
/* The following values can be changed to suit your needs.             */
/*---------------------------------------------------------------------*/

#define MAX_FILE_NAME              255  /* maximum length of fully qualified file */
#define MAX_MACRO_DIRS              20  /* maximum number of directories in THE_MACRO_PATH */
#define MAX_COMMAND_LENGTH         150  /* maximum length of a command */
#define MAX_LENGTH_OF_LINE        2048  /* default maximum length of a line */
#define MAX_COMMANDS                10  /* default maximum number of commands allowed on command line */
#define MAX_RECV                    20  /* number of lines that can be recovered */
#define MAX_SAVED_COMMANDS          20  /* number of commands that can be retrieved */
#define MAX_NUMTABS                 32  /* number of tab stops that can be defined */

#if defined(SYSVR4)
#   define THE_HOME_DIRECTORY          "/opt/THE/"
#else
#   define THE_HOME_DIRECTORY          "/usr/local/THE/"
#endif

/*---------------------------------------------------------------------*/
/* The following macros may need to be changed for your paltform. These*/
/* macros can be changed in this file or added to the compile command  */
/* in the makefile.                                                    */
/*---------------------------------------------------------------------*/
/* NO_RENAME define this if your standard libraries do not have the    */
/*           rename() function.                                        */
/*           Known systems without rename(): ATT System V 3.2,         */
/*           Xenix 2.3                                                 */
/*---------------------------------------------------------------------*/
/*#define NO_RENAME*/

/*---------------------------------------------------------------------*/
/* NO_KEYPAD define this if your curses library does not have the      */
/*           keypad() function.                                        */
/*           This macro is set automatically for BSD compatible curses */
/*           libraries.                                                */
/*---------------------------------------------------------------------*/
/*#define NO_KEYPAD*/

/*---------------------------------------------------------------------*/
/* NO_CURS_SET define macro if your curses library does not have the   */
/*             curs_set() function.                                    */
/*             This macro is set automatically if the curses version is*/
/*             either a BSD version, or is a System V release less than*/
/*             3.1, or if using AIX Extended Curses (USE_EXTCURS macro */
/*             is defined).                                            */
/*---------------------------------------------------------------------*/
/*#define NO_CURS_SET*/

/*---------------------------------------------------------------------*/
/* USE_NOTIMEOUT define this macro if you do not want to be able to use*/
/*               the ESCAPE key as a valid function key.               */
/*---------------------------------------------------------------------*/
/*#define USE_NOTIMEOUT*/

/*---------------------------------------------------------------------*/
/* BSD_STANDOUT change this if you are compiling with BSD curses and   */
/*              your BSD curses defines its STANDOUT macro different   */
/*              from the "standard" BSD macro value of _STANDOUT.      */
/*              A known "non-standard" BSD is FreeBSD which uses       */
/*              __WSTANDOUT.                                           */
/*---------------------------------------------------------------------*/
#define BSD_STANDOUT _STANDOUT

/*---------------------------------------------------------------------*/
/* The following values should not be changed unless you know what you */
/* are doing !                                                         */
/*---------------------------------------------------------------------*/
typedef unsigned char  ROWTYPE;
typedef unsigned char  COLTYPE;
typedef unsigned char  CHARTYPE;
typedef unsigned short LENGTHTYPE;
typedef long           LINETYPE;
typedef unsigned char  SELECTTYPE;
