/***********************************************************************/
/* QUERY.H -                                                           */
/* This file contains defines   related to QUERY,STATUS and EXTRACT    */
/***********************************************************************/
/*
 * THE - The Hessling Editor. A text editor similar to VM/CMS xedit.
 * Copyright (C) 1991-1995 Mark Hessling
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to:
 *
 *    The Free Software Foundation, Inc.
 *    675 Mass Ave,
 *    Cambridge, MA 02139 USA.
 *
 *
 * If you make modifications to this software that you feel increases
 * it usefulness for the rest of the community, please email the
 * changes, enhancements, bug fixes as well as any and all ideas to me.
 * This software is going to be maintained and enhanced as deemed
 * necessary by the community.
 *
 * Mark Hessling                     email: M.Hessling@gu.edu.au
 * 36 David Road                     Phone: +61 7 849 7731
 * Holland Park                      Fax:   +61 7 875 5314
 * QLD 4121
 * Australia
 */

/*
$Id: query.h 2.0 1995/01/26 16:31:50 MH Release MH $
*/


/*---------------------------------------------------------------------*/
/* The order of these items determine the order they appear as a result*/
/* of the STATUS command, so they should be in alphabetical order.     */
/*---------------------------------------------------------------------*/
/* The following are item number defines for EXTRACT/QUERY/STATUS.     */
/*---------------------------------------------------------------------*/
#define ITEM_ALT                              0
#define ITEM_ARBCHAR                          1
#define ITEM_AUTOSAVE                         2
#define ITEM_BACKUP                           3
#define ITEM_BEEP                             4
#define ITEM_BLOCK                            5
#define ITEM_CASE                             6
#define ITEM_CLEARSCREEN                      7
#define ITEM_CLOCK                            8
#define ITEM_CMDARROWS                        9
#define ITEM_CMDLINE                         10
#define ITEM_COMPAT                          11
#define ITEM_CURLINE                         12
#define ITEM_CURSOR                          13
#define ITEM_DIRFILEID                       14
#define ITEM_DISPLAY                         15
#define ITEM_EOF                             16
#define ITEM_EOLOUT                          17
#define ITEM_ETMODE                          18
#define ITEM_FNAME                           19
#define ITEM_FPATH                           20
#define ITEM_FTYPE                           21
#define ITEM_GETENV                          22
#define ITEM_HEX                             23
#define ITEM_HEXDISPLAY                      24
#define ITEM_HEXSHOW                         25
#define ITEM_IDLINE                          26
#define ITEM_IMPMACRO                        27
#define ITEM_IMPOS                           28
#define ITEM_INSERTMODE                      29
#define ITEM_LASTMSG                         30
#define ITEM_LASTRC                          31
#define ITEM_LENGTH                          32
#define ITEM_LINE                            33
#define ITEM_LINEND                          34
#define ITEM_MACROEXT                        35
#define ITEM_MACROPATH                       36
#define ITEM_MARGINS                         37
#define ITEM_MONITOR                         38
#define ITEM_MSGLINE                         39
#define ITEM_MSGMODE                         40
#define ITEM_NBFILE                          41
#define ITEM_NEWLINES                        42
#define ITEM_NONDISP                         43
#define ITEM_NUMBER                          44
#define ITEM_PENDING                         45
#define ITEM_POINT                           46
#define ITEM_POSITION                        47
#define ITEM_PREFIX                          48
#define ITEM_PRINTER                         49
#define ITEM_READV                           50
#define ITEM_REPROFILE                       51
#define ITEM_RESERVED                        52
#define ITEM_REXXOUTPUT                      53
#define ITEM_SCALE                           54
#define ITEM_SCOPE                           55
#define ITEM_SELECT                          56
#define ITEM_SHADOW                          57
#define ITEM_SIZE                            58
#define ITEM_STATUSLINE                      59
#define ITEM_STAY                            60
#define ITEM_TABKEY                          61
#define ITEM_TABLINE                         62
#define ITEM_TABS                            63
#define ITEM_TABSIN                          64
#define ITEM_TABSOUT                         65
#define ITEM_TERMINAL                        66
#define ITEM_TOF                             67
#define ITEM_VERIFY                          68
#define ITEM_VERSHIFT                        69
#define ITEM_VERSION                         70
#define ITEM_WIDTH                           71
#define ITEM_WORDWRAP                        72
#define ITEM_ZONE                            73
/*---------------------------------------------------------------------*/
/* The following are item number defines for the boolean functions.    */
/*---------------------------------------------------------------------*/
#define ITEM_AFTER_FUNCTION                 100
#define ITEM_BEFORE_FUNCTION                101
#define ITEM_BLANK_FUNCTION                 102
#define ITEM_BLOCK_FUNCTION                 103
#define ITEM_BOTTOMEDGE_FUNCTION            104
#define ITEM_COMMAND_FUNCTION               105
#define ITEM_CURRENT_FUNCTION               106
#define ITEM_DIR_FUNCTION                   107
#define ITEM_END_FUNCTION                   108
#define ITEM_EOF_FUNCTION                   109
#define ITEM_FILELINE_FUNCTION              110
#define ITEM_FIRST_FUNCTION                 111
#define ITEM_FOCUSEOF_FUNCTION              112
#define ITEM_FOCUSTOF_FUNCTION              113
#define ITEM_INBLOCK_FUNCTION               114
#define ITEM_INCOMMAND_FUNCTION             115
#define ITEM_INITIAL_FUNCTION               116
#define ITEM_INPREFIX_FUNCTION              117
#define ITEM_LEFTEDGE_FUNCTION              118
#define ITEM_MODIFIABLE_FUNCTION            119
#define ITEM_MULTWINDOW_FUNCTION            120
#define ITEM_RIGHTEDGE_FUNCTION             121
#define ITEM_SPACECHAR_FUNCTION             122
#define ITEM_TOF_FUNCTION                   123
#define ITEM_TOPEDGE_FUNCTION               124
#define ITEM_VERONE_FUNCTION                125
/*---------------------------------------------------------------------*/
/* The following are item number defines for the 'other' functions.    */
/*---------------------------------------------------------------------*/
#define ITEM_VALID_TARGET_FUNCTION          201

#define MAX_VARIABLES_RETURNED               20
