/* setpri.c
   program to change priority of a process or a user.
   useful for managing system cpu resorces, especially when large
   background jobs are running.
   command format: 'setpri -p|-u {process|user} {priority}'
   if you don't enter process|user or priority you will be prompted.
   mainly useful to root user. (-20 max priority - 20 min priority)
   most processes apparently start with a priority of 0.
   if a getty or ksh process priority is changed, all processes which
   spawn or shell off of that process apparently keep the changed priority.
   compile with 'cc setpri.c -O -osetpri -ls'
*/

#include <stdio.h>
#include <sys/resource.h>
#include <usersec.h>

main(int argc, char *argv[])
{
int process_to_change = 0;
uid_t user_to_change = 0;
char User[30];
int priority_to_set = 0;
char temp_string[6];
char mode[3];

if (argc == 1 || ( (strcmp(argv[1],"-p\0")!=0) && 
    (strcmp(argv[1],"-u\0")!=0) ) )
   { /* display command format */
   printf("Command Format: setpri -p|-u {process|user} {priority}\n");
   exit(0);
   } 
   else
   { /* get processing 'mode' */
   strcpy(mode,argv[1]);
   }
if (argc > 2)
   {
   switch (mode[1])
      {
      case 'p' : process_to_change = atoi(argv[2]);
                 break;
      case 'u' : strcpy(User,argv[2]);
                 getuserattr(User,S_ID,&user_to_change,SEC_INT);
                 if (user_to_change != 0)
                    {
                    printf("User %s id is %i\n",User,user_to_change);
                    }
                    else
                    {
                    printf("User %s not found\n",User);
                    exit(0);
                    }
                 break;
      default  : exit(0); 
      }
   }
   else
   { 
   while (process_to_change == 0 && user_to_change == 0)
      {
      switch (mode[1])
         {
         case 'p' : printf("Enter Process to Change Priority of: ");
                    temp_string[0] = '\0';
                    gets(temp_string);
                    process_to_change = atoi(temp_string);
                    break;
         case 'u' : printf("Enter User to Change Priority of: ");
                    gets(User);
                    getuserattr(User,S_ID,&user_to_change,SEC_INT);
                    if (user_to_change != 0)
                       {
                       printf("User %s id is %i\n",User,user_to_change);
                       }
                       else
                       {
                       printf("User %s not found\n",User);
                       }
                    break;
         default  : exit(0);
         }
      }
   }
/* show current priority and prompt for new priority if necessary */
switch(mode[1])
   {
   case 'p' : printf("Current Priority of %i is %i\n",process_to_change,
              getpriority(PRIO_PROCESS,process_to_change));
              break;
   case 'u' : printf("Current Priority of %s is %i\n",User,
              getpriority(PRIO_USER,user_to_change));
              break;
   default  : exit(0);
   }
if (argc > 3)
   {
   priority_to_set = atoi(argv[3]);
   }
   else
   {
   printf("Enter Priority to Set (-20 highest to 20 lowest): ");
   temp_string[0] = '\0';
   gets(temp_string);
   priority_to_set = atoi(temp_string);
   }
if (priority_to_set < -20 || priority_to_set > 20)
   {
   printf("ERROR invalid priority setting\n"); exit(0);
   }
/* set the priorities */
switch (mode[1])
   {
   case 'p' : setpriority(PRIO_PROCESS,process_to_change,priority_to_set);
              printf("Current Priority of %i is now %i\n",process_to_change,
              getpriority(PRIO_PROCESS,process_to_change) );
              break;
   case 'u' : setpriority(PRIO_USER,user_to_change,priority_to_set);
              printf("Current Priority of %s is now %i\n",User,
              getpriority(PRIO_USER,user_to_change) );
              break;
   default  : exit(0);
   }
printf("C'est Tout\n");
}

